"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var symbols_1 = require("./symbols");
function createActionDecorator(decoratorSymbol) {
    return function () { return function (target, propertyKey, descriptor) {
        var constructor = target.constructor;
        var decoratedActionNames = Reflect.getMetadata(decoratorSymbol, constructor) || [];
        Reflect.defineMetadata(decoratorSymbol, tslib_1.__spread(decoratedActionNames, [propertyKey]), constructor);
        return descriptor;
    }; };
}
exports.ImmerReducer = createActionDecorator(symbols_1.IMMER_REDUCER_DECORATOR_SYMBOL);
exports.Reducer = createActionDecorator(symbols_1.REDUCER_DECORATOR_SYMBOL);
exports.Effect = createActionDecorator(symbols_1.EFFECT_DECORATOR_SYMBOL);
exports.DefineAction = createActionDecorator(symbols_1.DEFINE_ACTION_DECORATOR_SYMBOL);
