import { Observable, ReplaySubject } from 'rxjs';
import { Reducer } from 'react';
export declare type State<S> = {
    getState: () => S;
    dispatch: <T>(action: Action<T>) => void;
    subscribeAction: (observer: (action: Action<unknown>) => void) => () => void;
    unsubscribe: () => void;
};
export declare type StateCreator<S> = {
    (defaultState: S, middleware?: (effect$: Observable<Action<unknown>>) => Observable<Action<unknown>>, loadFromSSR?: boolean): State<S>;
};
export interface Action<T = unknown> {
    readonly type: string | symbol;
    readonly payload: T;
}
export declare type Option<T> = T | undefined;
export declare type Epic<T> = (action$: Observable<Action<T>>, loadFromSSR: boolean) => Observable<Action<unknown>>;
export declare function createState<S>(reducer: Reducer<S, Action<unknown>>, effect: Epic<unknown>): {
    stateCreator: StateCreator<S>;
    action$: Observable<Action<unknown>>;
    state$: ReplaySubject<S>;
};
