"use strict";
/* istanbul ignore next */
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var terminate_1 = require("./ssr/terminate");
var devtool = {
    send: rxjs_1.noop,
    init: rxjs_1.noop,
};
var FakeReduxDevTools = {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    connect: function () { return devtool; },
};
exports.INIT_ACTION_TYPE = 'INIT_AYANAMI_STATE';
var ReduxDevTools = (_a = (typeof window !== 'undefined' && window.__REDUX_DEVTOOLS_EXTENSION__), (_a !== null && _a !== void 0 ? _a : FakeReduxDevTools));
var STATE = {};
exports.logStateAction = function (action) {
    var _a;
    if (action.type === terminate_1.TERMINATE_ACTION.type) {
        return;
    }
    var namespace = action.state.name;
    var _action = {
        type: namespace + "/" + String(action.type),
        params: filterParams(action.payload),
    };
    STATE[namespace] = action.state.getState();
    if (!((_a = action.type) === null || _a === void 0 ? void 0 : _a.endsWith(exports.INIT_ACTION_TYPE))) {
        devtool.send(_action, STATE);
    }
};
if (process.env.NODE_ENV !== 'development') {
    exports.logStateAction = rxjs_1.noop;
}
exports.initDevtool = function () {
    if (process.env.NODE_ENV === 'development') {
        devtool = ReduxDevTools.connect({
            name: "Ayanami",
        });
        devtool.init(STATE);
    }
};
function filterParams(params) {
    if (params && typeof params === 'object' && typeof Event !== 'undefined') {
        if (params instanceof Event) {
            return "<<Event:" + params.type + ">>";
        }
        else if (params.nativeEvent instanceof Event) {
            return "<<SyntheticEvent:" + params.nativeEvent.type + ">>";
        }
    }
    return params;
}
