"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
require("reflect-metadata");
var react_1 = tslib_1.__importDefault(require("react"));
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var di_1 = require("@asuka/di");
var server_1 = require("react-dom/server");
var react_test_renderer_1 = require("react-test-renderer");
var uniqueId_1 = tslib_1.__importDefault(require("lodash/uniqueId"));
var index_1 = require("../index");
var core_1 = require("../../core");
var hooks_1 = require("../../hooks");
var constants_1 = require("../constants");
var ssr_context_1 = require("../ssr-context");
var ssr_states_1 = require("../ssr-states");
var CountModel = /** @class */ (function (_super) {
    tslib_1.__extends(CountModel, _super);
    function CountModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.defaultState = { count: 0, name: '' };
        return _this;
    }
    CountModel.prototype.setCount = function (state, count) {
        state.count = count;
    };
    CountModel.prototype.setName = function (state, name) {
        state.name = name;
    };
    CountModel.prototype.getCount = function (payload$) {
        var _this = this;
        return payload$.pipe(operators_1.flatMap(function () {
            return rxjs_1.timer(20).pipe(operators_1.map(function () { return _this.getActions().setCount(1); }), operators_1.endWith(index_1.TERMINATE_ACTION));
        }));
    };
    CountModel.prototype.skippedEffect = function (payload$) {
        var _this = this;
        return payload$.pipe(operators_1.switchMap(function (name) {
            return rxjs_1.timer(20).pipe(operators_1.map(function () { return _this.getActions().setName(name); }), operators_1.endWith(index_1.TERMINATE_ACTION));
        }));
    };
    tslib_1.__decorate([
        core_1.ImmerReducer(),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Object, Number]),
        tslib_1.__metadata("design:returntype", void 0)
    ], CountModel.prototype, "setCount", null);
    tslib_1.__decorate([
        core_1.ImmerReducer(),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Object, String]),
        tslib_1.__metadata("design:returntype", void 0)
    ], CountModel.prototype, "setName", null);
    tslib_1.__decorate([
        index_1.SSREffect(),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [rxjs_1.Observable]),
        tslib_1.__metadata("design:returntype", rxjs_1.Observable)
    ], CountModel.prototype, "getCount", null);
    tslib_1.__decorate([
        index_1.SSREffect({
            payloadGetter: function (ctx, skip) { return ctx.url || skip(); },
            skipFirstClientDispatch: false,
        }),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [rxjs_1.Observable]),
        tslib_1.__metadata("design:returntype", rxjs_1.Observable)
    ], CountModel.prototype, "skippedEffect", null);
    CountModel = tslib_1.__decorate([
        core_1.Module('CountModel')
    ], CountModel);
    return CountModel;
}(core_1.Ayanami));
var TipModel = /** @class */ (function (_super) {
    tslib_1.__extends(TipModel, _super);
    function TipModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.defaultState = { tip: '' };
        return _this;
    }
    TipModel.prototype.setTip = function (state, tip) {
        state.tip = tip;
    };
    TipModel.prototype.getTip = function (payload$) {
        var _this = this;
        return payload$.pipe(operators_1.mergeMap(function () {
            return rxjs_1.timer(1).pipe(operators_1.map(function () { return _this.getActions().setTip('tip'); }), operators_1.endWith(index_1.TERMINATE_ACTION));
        }));
    };
    tslib_1.__decorate([
        core_1.ImmerReducer(),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Object, String]),
        tslib_1.__metadata("design:returntype", void 0)
    ], TipModel.prototype, "setTip", null);
    tslib_1.__decorate([
        index_1.SSREffect(),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [rxjs_1.Observable]),
        tslib_1.__metadata("design:returntype", rxjs_1.Observable)
    ], TipModel.prototype, "getTip", null);
    TipModel = tslib_1.__decorate([
        core_1.Module('TipModel')
    ], TipModel);
    return TipModel;
}(core_1.Ayanami));
var Component = function () {
    var _a = tslib_1.__read(hooks_1.useAyanami(CountModel), 2), state = _a[0], actions = _a[1];
    react_1.default.useEffect(function () {
        actions.setName('new name');
    }, []);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("span", null, state.count)));
};
var ComponentWithSelector = function () {
    var _a = tslib_1.__read(hooks_1.useAyanami(CountModel, {
        selector: function (s) { return ({
            count: s.count + 1,
        }); },
    }), 2), state = _a[0], actions = _a[1];
    react_1.default.useEffect(function () {
        actions.setName('new name');
    }, []);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("span", null, state.count)));
};
describe('SSR specs:', function () {
    beforeEach(function () {
        ssr_states_1.SSRStateCacheInstance.setPoolSize(100);
        di_1.rootInjector.addProviders([CountModel, TipModel]);
    });
    afterEach(function () {
        ssr_states_1.SSRStateCacheInstance.setPoolSize(0);
        di_1.rootInjector.reset();
    });
    it('should throw if module name not given', function () {
        function generateException() {
            var ErrorModel = /** @class */ (function (_super) {
                tslib_1.__extends(ErrorModel, _super);
                function ErrorModel() {
                    var _this = _super !== null && _super.apply(this, arguments) || this;
                    _this.defaultState = {};
                    return _this;
                }
                ErrorModel = tslib_1.__decorate([
                    (core_1.Module())
                ], ErrorModel);
                return ErrorModel;
            }(core_1.Ayanami));
            return ErrorModel;
        }
        expect(generateException).toThrow();
    });
    it('should pass valid module name', function () {
        var Model = /** @class */ (function (_super) {
            tslib_1.__extends(Model, _super);
            function Model() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.defaultState = {};
                return _this;
            }
            Model = tslib_1.__decorate([
                core_1.Module('1')
            ], Model);
            return Model;
        }(core_1.Ayanami));
        var Model2 = /** @class */ (function (_super) {
            tslib_1.__extends(Model2, _super);
            function Model2() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.defaultState = {};
                return _this;
            }
            Model2 = tslib_1.__decorate([
                core_1.Module('2')
            ], Model2);
            return Model2;
        }(core_1.Ayanami));
        function generateException1() {
            var ErrorModel1 = /** @class */ (function (_super) {
                tslib_1.__extends(ErrorModel1, _super);
                function ErrorModel1() {
                    var _this = _super !== null && _super.apply(this, arguments) || this;
                    _this.defaultState = {};
                    return _this;
                }
                ErrorModel1 = tslib_1.__decorate([
                    core_1.Module('1')
                ], ErrorModel1);
                return ErrorModel1;
            }(core_1.Ayanami));
            return ErrorModel1;
        }
        function generateException2() {
            var ErrorModel2 = /** @class */ (function (_super) {
                tslib_1.__extends(ErrorModel2, _super);
                function ErrorModel2() {
                    var _this = _super !== null && _super.apply(this, arguments) || this;
                    _this.defaultState = {};
                    return _this;
                }
                ErrorModel2 = tslib_1.__decorate([
                    core_1.Module('1')
                ], ErrorModel2);
                return ErrorModel2;
            }(core_1.Ayanami));
            return { ErrorModel2: ErrorModel2 };
        }
        function generateException3() {
            var ErrorModel = /** @class */ (function (_super) {
                tslib_1.__extends(ErrorModel, _super);
                function ErrorModel() {
                    var _this = _super !== null && _super.apply(this, arguments) || this;
                    _this.defaultState = {};
                    return _this;
                }
                ErrorModel = tslib_1.__decorate([
                    (core_1.Module())
                ], ErrorModel);
                return ErrorModel;
            }(core_1.Ayanami));
            return ErrorModel;
        }
        expect(Model).not.toBe(undefined);
        expect(Model2).not.toBe(undefined);
        expect(generateException1).toThrow();
        expect(generateException2).toThrow();
        expect(generateException3).toThrow();
    });
    it('should run ssr effects', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var state, moduleState;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.emitSSREffects({ url: 'name' }, [CountModel])];
                case 1:
                    state = _a.sent();
                    moduleState = state['CountModel'];
                    expect(moduleState).not.toBe(undefined);
                    expect(moduleState.count).toBe(1);
                    expect(moduleState.name).toBe('name');
                    expect(state).toMatchSnapshot();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should skip effect if it returns SKIP_SYMBOL', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var state, moduleState;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.emitSSREffects({}, [CountModel])];
                case 1:
                    state = _a.sent();
                    moduleState = state['CountModel'];
                    expect(moduleState.name).toBe('');
                    expect(state).toMatchSnapshot();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should return right state in hooks', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var req, html;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    req = {};
                    return [4 /*yield*/, index_1.emitSSREffects(req, [CountModel])];
                case 1:
                    _a.sent();
                    html = server_1.renderToString(react_1.default.createElement(ssr_context_1.SSRContext.Provider, { value: req },
                        react_1.default.createElement(Component, null)));
                    expect(html).toContain('<span>1</span>');
                    expect(html).toMatchSnapshot();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should restore state from global', function () {
        // @ts-ignore
        global[constants_1.GLOBAL_KEY] = {
            CountModel: {
                count: 1,
                name: '',
            },
        };
        var testRenderer = react_test_renderer_1.create(react_1.default.createElement(Component, null));
        react_test_renderer_1.act(function () {
            testRenderer.update(react_1.default.createElement(Component, null));
        });
        expect(testRenderer.root.findByType('span').children[0]).toBe('1');
        // @ts-ignore
        delete global[constants_1.GLOBAL_KEY];
        testRenderer.unmount();
    });
    it('should restore state from global #with selector', function () {
        // @ts-ignore
        global[constants_1.GLOBAL_KEY] = {
            CountModel: {
                count: 10,
                name: '',
            },
        };
        var testRenderer = react_test_renderer_1.create(react_1.default.createElement(ComponentWithSelector, null));
        react_test_renderer_1.act(function () {
            testRenderer.update(react_1.default.createElement(ComponentWithSelector, null));
        });
        expect(testRenderer.root.findByType('span').children[0]).toBe('10');
        // @ts-ignore
        delete global[constants_1.GLOBAL_KEY];
        testRenderer.unmount();
    });
    it('should not restore state from global if state is null', function () {
        // @ts-ignore
        global[constants_1.GLOBAL_KEY] = {
            OtherModule: {
                count: 10,
                name: '',
            },
        };
        var testRenderer = react_test_renderer_1.create(react_1.default.createElement(ComponentWithSelector, null));
        react_test_renderer_1.act(function () {
            testRenderer.update(react_1.default.createElement(ComponentWithSelector, null));
        });
        expect(testRenderer.root.findByType('span').children[0]).toBe('1');
        // @ts-ignore
        delete global[constants_1.GLOBAL_KEY];
        testRenderer.unmount();
    });
    it('should restore and skip first action on client side', function () {
        var Component = function () {
            var _a = tslib_1.__read(hooks_1.useAyanami(CountModel), 2), state = _a[0], actions = _a[1];
            react_1.default.useEffect(function () {
                actions.getCount();
            }, []);
            return (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("span", null, state.count)));
        };
        // @ts-ignore
        global[constants_1.GLOBAL_KEY] = {
            CountModel: {
                count: 2,
                name: '',
            },
        };
        var testRenderer = react_test_renderer_1.create(react_1.default.createElement(Component, null));
        react_test_renderer_1.act(function () {
            testRenderer.update(react_1.default.createElement(Component, null));
        });
        expect(testRenderer.root.findByType('span').children[0]).toBe('2');
        // @ts-ignore
        delete global[constants_1.GLOBAL_KEY];
        testRenderer.unmount();
    });
    it('should support concurrency', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            return [2 /*return*/, Promise.all([
                    index_1.emitSSREffects({ url: 'name1' }, [CountModel, TipModel], 'concurrency1'),
                    index_1.emitSSREffects({ url: 'name2' }, [CountModel, TipModel], 'concurrency2'),
                ]).then(function (_a) {
                    var _b = tslib_1.__read(_a, 2), result1 = _b[0], result2 = _b[1];
                    expect(result1['CountModel'].name).toBe('name1');
                    expect(result2['CountModel'].name).toBe('name2');
                    expect({
                        firstRequest: result1,
                        secondRequest: result2,
                    }).toMatchSnapshot();
                })];
        });
    }); });
    it('should timeout', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var req, reqContext;
        return tslib_1.__generator(this, function (_a) {
            req = {};
            reqContext = uniqueId_1.default();
            return [2 /*return*/, index_1.emitSSREffects(req, [CountModel], reqContext, 0).catch(function (e) {
                    expect(e.message).toBe('Terminate timeout');
                })];
        });
    }); });
    it('should resolve empty object if no modules provided', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var req, state;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    req = {};
                    return [4 /*yield*/, index_1.emitSSREffects(req, [])];
                case 1:
                    state = _a.sent();
                    expect(state).toStrictEqual({});
                    return [2 /*return*/];
            }
        });
    }); });
    it('should do nothing if Module contains no SSREffects', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var req, WithoutSSRModule, state;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    req = {};
                    WithoutSSRModule = /** @class */ (function (_super) {
                        tslib_1.__extends(WithoutSSRModule, _super);
                        function WithoutSSRModule() {
                            var _this = _super !== null && _super.apply(this, arguments) || this;
                            _this.defaultState = {
                                count: 0,
                            };
                            return _this;
                        }
                        WithoutSSRModule.prototype.set = function (state, payload) {
                            state.count = payload;
                        };
                        WithoutSSRModule.prototype.addOne = function (payload$) {
                            var _this = this;
                            return payload$.pipe(operators_1.withLatestFrom(this.state$), operators_1.map(function (_a) {
                                var _b = tslib_1.__read(_a, 2), count = _b[1].count;
                                return _this.getActions().set(count + 1);
                            }));
                        };
                        tslib_1.__decorate([
                            core_1.ImmerReducer(),
                            tslib_1.__metadata("design:type", Function),
                            tslib_1.__metadata("design:paramtypes", [Object, Number]),
                            tslib_1.__metadata("design:returntype", void 0)
                        ], WithoutSSRModule.prototype, "set", null);
                        tslib_1.__decorate([
                            core_1.Effect(),
                            tslib_1.__metadata("design:type", Function),
                            tslib_1.__metadata("design:paramtypes", [rxjs_1.Observable]),
                            tslib_1.__metadata("design:returntype", rxjs_1.Observable)
                        ], WithoutSSRModule.prototype, "addOne", null);
                        WithoutSSRModule = tslib_1.__decorate([
                            core_1.Module('WithoutSSR')
                        ], WithoutSSRModule);
                        return WithoutSSRModule;
                    }(core_1.Ayanami));
                    return [4 /*yield*/, index_1.emitSSREffects(req, [WithoutSSRModule])];
                case 1:
                    state = _a.sent();
                    expect(state).toStrictEqual({});
                    return [2 /*return*/];
            }
        });
    }); });
    it('should throw error if runEffects error', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var req, error, SSRErrorModule, e_1;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    req = {};
                    error = new TypeError('whatever');
                    SSRErrorModule = /** @class */ (function (_super) {
                        tslib_1.__extends(SSRErrorModule, _super);
                        function SSRErrorModule() {
                            var _this = _super !== null && _super.apply(this, arguments) || this;
                            _this.defaultState = {
                                count: 0,
                            };
                            return _this;
                        }
                        SSRErrorModule.prototype.addOne = function (payload$) {
                            return payload$.pipe(operators_1.withLatestFrom(this.state$), operators_1.map(function () {
                                throw error;
                            }));
                        };
                        tslib_1.__decorate([
                            index_1.SSREffect(),
                            tslib_1.__metadata("design:type", Function),
                            tslib_1.__metadata("design:paramtypes", [rxjs_1.Observable]),
                            tslib_1.__metadata("design:returntype", rxjs_1.Observable)
                        ], SSRErrorModule.prototype, "addOne", null);
                        SSRErrorModule = tslib_1.__decorate([
                            core_1.Module('ErrorModule')
                        ], SSRErrorModule);
                        return SSRErrorModule;
                    }(core_1.Ayanami));
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, index_1.emitSSREffects(req, [SSRErrorModule])];
                case 2:
                    _a.sent();
                    throw new TypeError('Unreachable code path');
                case 3:
                    e_1 = _a.sent();
                    expect(e_1).toBe(error);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    it('should throw error if reducer throw', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var req, error, SSRErrorModule, e_2;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    req = {};
                    error = new TypeError('whatever');
                    SSRErrorModule = /** @class */ (function (_super) {
                        tslib_1.__extends(SSRErrorModule, _super);
                        function SSRErrorModule() {
                            var _this = _super !== null && _super.apply(this, arguments) || this;
                            _this.defaultState = {
                                count: 0,
                            };
                            return _this;
                        }
                        SSRErrorModule.prototype.set = function () {
                            throw error;
                        };
                        SSRErrorModule.prototype.addOne = function (payload$) {
                            var _this = this;
                            return payload$.pipe(operators_1.withLatestFrom(this.state$), operators_1.map(function () { return _this.getActions().set(); }));
                        };
                        tslib_1.__decorate([
                            core_1.Reducer(),
                            tslib_1.__metadata("design:type", Function),
                            tslib_1.__metadata("design:paramtypes", []),
                            tslib_1.__metadata("design:returntype", void 0)
                        ], SSRErrorModule.prototype, "set", null);
                        tslib_1.__decorate([
                            index_1.SSREffect(),
                            tslib_1.__metadata("design:type", Function),
                            tslib_1.__metadata("design:paramtypes", [rxjs_1.Observable]),
                            tslib_1.__metadata("design:returntype", rxjs_1.Observable)
                        ], SSRErrorModule.prototype, "addOne", null);
                        SSRErrorModule = tslib_1.__decorate([
                            core_1.Module('ErrorReducerModule')
                        ], SSRErrorModule);
                        return SSRErrorModule;
                    }(core_1.Ayanami));
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, index_1.emitSSREffects(req, [SSRErrorModule])];
                case 2:
                    _a.sent();
                    throw new TypeError('Unreachable code path');
                case 3:
                    e_2 = _a.sent();
                    expect(e_2).toBe(error);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    it('should throw error if payloadGetter throw', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var req, error, SSRErrorModule, e_3;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    req = {};
                    error = new TypeError('whatever');
                    SSRErrorModule = /** @class */ (function (_super) {
                        tslib_1.__extends(SSRErrorModule, _super);
                        function SSRErrorModule() {
                            var _this = _super !== null && _super.apply(this, arguments) || this;
                            _this.defaultState = {
                                count: 0,
                            };
                            return _this;
                        }
                        SSRErrorModule.prototype.set = function (state, payload) {
                            return tslib_1.__assign(tslib_1.__assign({}, state), { count: payload });
                        };
                        SSRErrorModule.prototype.addOne = function (payload$) {
                            var _this = this;
                            return payload$.pipe(operators_1.withLatestFrom(this.state$), operators_1.map(function (_a) {
                                var _b = tslib_1.__read(_a, 2), state = _b[1];
                                return _this.getActions().set(state.count + 1);
                            }));
                        };
                        tslib_1.__decorate([
                            core_1.Reducer(),
                            tslib_1.__metadata("design:type", Function),
                            tslib_1.__metadata("design:paramtypes", [Object, Number]),
                            tslib_1.__metadata("design:returntype", void 0)
                        ], SSRErrorModule.prototype, "set", null);
                        tslib_1.__decorate([
                            index_1.SSREffect({
                                payloadGetter: function () {
                                    throw error;
                                },
                            }),
                            tslib_1.__metadata("design:type", Function),
                            tslib_1.__metadata("design:paramtypes", [rxjs_1.Observable]),
                            tslib_1.__metadata("design:returntype", rxjs_1.Observable)
                        ], SSRErrorModule.prototype, "addOne", null);
                        SSRErrorModule = tslib_1.__decorate([
                            core_1.Module('ErrorMiddlewareModule')
                        ], SSRErrorModule);
                        return SSRErrorModule;
                    }(core_1.Ayanami));
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, index_1.emitSSREffects(req, [SSRErrorModule])];
                case 2:
                    _a.sent();
                    throw new TypeError('Unreachable code path');
                case 3:
                    e_3 = _a.sent();
                    expect(e_3).toBe(error);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    it('should reuse state if provider context', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var requestId, req1, req2, SharedComponent1, SharedComponent2, cachedState, result1, result2;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    requestId = uniqueId_1.default();
                    req1 = {};
                    req2 = {};
                    return [4 /*yield*/, index_1.emitSSREffects(req1, [CountModel], requestId)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, index_1.emitSSREffects(req2, [CountModel], requestId)];
                case 2:
                    _a.sent();
                    SharedComponent1 = function () {
                        var state = hooks_1.useAyanamiState(CountModel);
                        return (react_1.default.createElement(react_1.default.Fragment, null,
                            react_1.default.createElement("span", null, state.count)));
                    };
                    SharedComponent2 = function () {
                        var state = hooks_1.useAyanamiState(CountModel);
                        return (react_1.default.createElement(react_1.default.Fragment, null,
                            react_1.default.createElement("span", null, state.count)));
                    };
                    cachedState = ssr_states_1.SSRStateCacheInstance.get(requestId, CountModel);
                    expect(cachedState.getState().count).toBe(1);
                    result1 = server_1.renderToString(react_1.default.createElement(ssr_context_1.SSRSharedContext.Provider, { value: requestId },
                        react_1.default.createElement(SharedComponent1, null)));
                    result2 = server_1.renderToString(react_1.default.createElement(ssr_context_1.SSRSharedContext.Provider, { value: requestId },
                        react_1.default.createElement(SharedComponent2, null)));
                    expect(result1).toBe(result2);
                    return [2 /*return*/];
            }
        });
    }); });
});
