"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var di_1 = require("@asuka/di");
var AyanamiTestModule = /** @class */ (function (_super) {
    tslib_1.__extends(AyanamiTestModule, _super);
    function AyanamiTestModule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AyanamiTestModule.prototype.getAyanamiTestingStub = function (ayanamiModule) {
        var moduleInstance = this.getInstance(ayanamiModule);
        var state = moduleInstance.createState();
        var actionsCreator = moduleInstance.getActions();
        var dispatcher = Object.keys(actionsCreator).reduce(function (acc, key) {
            acc[key] = function (payload) {
                state.dispatch(actionsCreator[key](payload));
            };
            return acc;
        }, Object.create(null));
        return new AyanamiTestStub(dispatcher, state);
    };
    return AyanamiTestModule;
}(di_1.TestModule));
exports.AyanamiTestModule = AyanamiTestModule;
var AyanamiTestStub = /** @class */ (function () {
    function AyanamiTestStub(dispatcher, state) {
        this.dispatcher = dispatcher;
        this.state = state;
    }
    AyanamiTestStub.prototype.getState = function () {
        return this.state.getState();
    };
    return AyanamiTestStub;
}());
exports.AyanamiTestStub = AyanamiTestStub;
