import { __read, __spread } from "tslib";
import { IMMER_REDUCER_DECORATOR_SYMBOL, REDUCER_DECORATOR_SYMBOL, EFFECT_DECORATOR_SYMBOL, DEFINE_ACTION_DECORATOR_SYMBOL, } from './symbols';
function createActionDecorator(decoratorSymbol) {
    return function () { return function (target, propertyKey, descriptor) {
        var constructor = target.constructor;
        var decoratedActionNames = Reflect.getMetadata(decoratorSymbol, constructor) || [];
        Reflect.defineMetadata(decoratorSymbol, __spread(decoratedActionNames, [propertyKey]), constructor);
        return descriptor;
    }; };
}
export var ImmerReducer = createActionDecorator(IMMER_REDUCER_DECORATOR_SYMBOL);
export var Reducer = createActionDecorator(REDUCER_DECORATOR_SYMBOL);
export var Effect = createActionDecorator(EFFECT_DECORATOR_SYMBOL);
export var DefineAction = createActionDecorator(DEFINE_ACTION_DECORATOR_SYMBOL);
