import { Injectable } from '@asuka/di';
var configSets = new Set();
export var Module = function (name) {
    if (typeof name !== 'string') {
        throw new TypeError('Module name should be string');
    }
    if (configSets.has(name)) {
        throw new Error("Duplicated Module name: " + name);
    }
    configSets.add(name);
    return function (target) {
        target.prototype.moduleName = name;
        return Injectable()(target);
    };
};
