/* istanbul ignore next */
var _a;
import { noop } from 'rxjs';
import { TERMINATE_ACTION } from './ssr/terminate';
var devtool = {
    send: noop,
    init: noop,
};
var FakeReduxDevTools = {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    connect: function () { return devtool; },
};
export var INIT_ACTION_TYPE = 'INIT_AYANAMI_STATE';
var ReduxDevTools = (_a = (typeof window !== 'undefined' && window.__REDUX_DEVTOOLS_EXTENSION__), (_a !== null && _a !== void 0 ? _a : FakeReduxDevTools));
var STATE = {};
export var logStateAction = function (action) {
    var _a;
    if (action.type === TERMINATE_ACTION.type) {
        return;
    }
    var namespace = action.state.name;
    var _action = {
        type: namespace + "/" + String(action.type),
        params: filterParams(action.payload),
    };
    STATE[namespace] = action.state.getState();
    if (!((_a = action.type) === null || _a === void 0 ? void 0 : _a.endsWith(INIT_ACTION_TYPE))) {
        devtool.send(_action, STATE);
    }
};
if (process.env.NODE_ENV !== 'development') {
    logStateAction = noop;
}
export var initDevtool = function () {
    if (process.env.NODE_ENV === 'development') {
        devtool = ReduxDevTools.connect({
            name: "Ayanami",
        });
        devtool.init(STATE);
    }
};
function filterParams(params) {
    if (params && typeof params === 'object' && typeof Event !== 'undefined') {
        if (params instanceof Event) {
            return "<<Event:" + params.type + ">>";
        }
        else if (params.nativeEvent instanceof Event) {
            return "<<SyntheticEvent:" + params.nativeEvent.type + ">>";
        }
    }
    return params;
}
