import { __assign } from "tslib";
import { SSRSymbol, ACTION_TO_SKIP_KEY } from './constants';
import { Effect } from '../core/decorators';
export var SKIP_SYMBOL = Symbol('skip');
function addDecorator(target, method, middleware) {
    var existedMetas = Reflect.getMetadata(SSRSymbol, target);
    var meta = { action: method, middleware: middleware };
    if (existedMetas) {
        existedMetas.push(meta);
    }
    else {
        Reflect.defineMetadata(SSRSymbol, [meta], target);
    }
}
export function SSREffect(options) {
    var _a = __assign({ payloadGetter: undefined, skipFirstClientDispatch: true }, options), payloadGetter = _a.payloadGetter, skipFirstClientDispatch = _a.skipFirstClientDispatch;
    return function (target, method, descriptor) {
        addDecorator(target, method, payloadGetter);
        if (skipFirstClientDispatch) {
            var actionsToSkip = Reflect.getMetadata(ACTION_TO_SKIP_KEY, target) || new Set();
            actionsToSkip.add(method);
            Reflect.defineMetadata(ACTION_TO_SKIP_KEY, actionsToSkip, target);
        }
        return Effect()(target, method, descriptor);
    };
}
