import { __read, __values } from "tslib";
var SSRStateCache = /** @class */ (function () {
    function SSRStateCache() {
        var _this = this;
        this.SSRStates = new Map();
        this.size = 1000;
        this.cleanupStateByContext = function (ctx) {
            var e_1, _a;
            var states = _this.SSRStates.get(ctx);
            if (states) {
                try {
                    for (var states_1 = __values(states), states_1_1 = states_1.next(); !states_1_1.done; states_1_1 = states_1.next()) {
                        var _b = __read(states_1_1.value, 2), state = _b[1];
                        state.unsubscribe();
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (states_1_1 && !states_1_1.done && (_a = states_1.return)) _a.call(states_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            _this.SSRStates.delete(ctx);
        };
    }
    SSRStateCache.prototype.setPoolSize = function (size) {
        if (this.SSRStates.size >= size) {
            this.SSRStates.clear();
        }
        this.size = size;
    };
    SSRStateCache.prototype.has = function (ctx, constructor) {
        return this.SSRStates.has(ctx) && this.SSRStates.get(ctx).has(constructor);
    };
    SSRStateCache.prototype.get = function (ctx, constructor) {
        var _a;
        return (_a = this.SSRStates.get(ctx)) === null || _a === void 0 ? void 0 : _a.get(constructor);
    };
    SSRStateCache.prototype.set = function (ctx, constructor, state) {
        if (this.SSRStates.size >= this.size) {
            this.SSRStates.clear();
        }
        if (this.SSRStates.has(ctx)) {
            this.SSRStates.get(ctx).set(constructor, state);
        }
        else {
            var caches_1 = new Map();
            caches_1.set(constructor, state);
            this.SSRStates.set(ctx, caches_1);
        }
    };
    return SSRStateCache;
}());
export { SSRStateCache };
export var SSRStateCacheInstance = new SSRStateCache();
