import { Observable } from 'rxjs';
import { Action, State } from './state';
import { InstanceActionOfAyanami, ActionStreamOfAyanami } from './types';
export declare abstract class Ayanami<S> {
    abstract readonly defaultState: S;
    state$: Observable<S>;
    private stateCreator;
    private readonly _actions;
    private readonly _actionStreams;
    private _defineActionKeys;
    private readonly action$;
    private readonly effect;
    private readonly reducer;
    constructor();
    createState(middleware?: (effect$: Observable<Action<unknown>>) => Observable<Action<unknown>>): State<S>;
    getActions<M extends Ayanami<S>>(this: M): M extends Ayanami<infer State> ? InstanceActionOfAyanami<M, State> : never;
    getAction$<M extends Ayanami<S>>(this: M): M extends Ayanami<infer State> ? ActionStreamOfAyanami<M, State> : ActionStreamOfAyanami<M, S>;
    protected createNoopAction(): Action<null>;
    private combineEffects;
    private combineReducers;
    private combineDefineActions;
}
