import { IMMER_REDUCER_DECORATOR_SYMBOL, REDUCER_DECORATOR_SYMBOL, EFFECT_DECORATOR_SYMBOL, DEFINE_ACTION_DECORATOR_SYMBOL, } from './symbols';
function createActionDecorator(decoratorSymbol) {
    return () => (target, propertyKey, descriptor) => {
        const constructor = target.constructor;
        const decoratedActionNames = Reflect.getMetadata(decoratorSymbol, constructor) || [];
        Reflect.defineMetadata(decoratorSymbol, [...decoratedActionNames, propertyKey], constructor);
        return descriptor;
    };
}
export const ImmerReducer = createActionDecorator(IMMER_REDUCER_DECORATOR_SYMBOL);
export const Reducer = createActionDecorator(REDUCER_DECORATOR_SYMBOL);
export const Effect = createActionDecorator(EFFECT_DECORATOR_SYMBOL);
export const DefineAction = createActionDecorator(DEFINE_ACTION_DECORATOR_SYMBOL);
