import { Injectable } from '@asuka/di';
const configSets = new Set();
export const Module = (name) => {
    if (typeof name !== 'string') {
        throw new TypeError('Module name should be string');
    }
    if (configSets.has(name)) {
        throw new Error(`Duplicated Module name: ${name}`);
    }
    configSets.add(name);
    return (target) => {
        target.prototype.moduleName = name;
        return Injectable()(target);
    };
};
