import { Draft } from 'immer';
import { Ayanami, ConstructorOf, ActionOfAyanami } from './core';
export declare type StateSelector<S, U> = {
    (state: S): U;
};
export declare type StateSelectorConfig<S, U> = {
    selector?: StateSelector<S, U>;
    mutateStateOnFirstRendering?: (s: Draft<S>) => void;
};
export declare function useAyanamiDispatchers<M extends Ayanami<S>, S = any>(A: ConstructorOf<M>): ActionOfAyanami<M, S>;
export declare function useAyanamiState<M extends Ayanami<any>>(A: ConstructorOf<M>): M extends Ayanami<infer State> ? State : never;
export declare function useAyanamiState<M extends Ayanami<any>, U>(A: ConstructorOf<M>, config: M extends Ayanami<infer State> ? {
    mutateStateOnFirstRendering?: (s: Draft<State>) => void;
    selector: StateSelector<State, U>;
} : never): M extends Ayanami<infer State> ? typeof config['selector'] extends StateSelector<State, infer NewState> ? NewState : never : never;
export declare function useAyanamiState<M extends Ayanami<any>, U>(A: ConstructorOf<M>, config: M extends Ayanami<infer State> ? {
    mutateStateOnFirstRendering: (s: Draft<State>) => void;
} : never): M extends Ayanami<infer State> ? State : never;
export declare function useAyanami<M extends Ayanami<any>>(A: ConstructorOf<M>): M extends Ayanami<infer State> ? [State, ActionOfAyanami<M, State>] : never;
export declare function useAyanami<M extends Ayanami<any>, U>(A: ConstructorOf<M>, config: M extends Ayanami<infer State> ? {
    selector: StateSelector<State, U>;
    mutateStateOnFirstRendering?: (s: Draft<State>) => void;
} : never): M extends Ayanami<infer State> ? typeof config['selector'] extends StateSelector<State, infer NewState> ? [NewState, ActionOfAyanami<M, State>] : never : never;
export declare function useAyanami<M extends Ayanami<any>, U>(A: ConstructorOf<M>, config: M extends Ayanami<infer State> ? {
    mutateStateOnFirstRendering: (s: Draft<State>) => void;
} : never): M extends Ayanami<infer State> ? [State, ActionOfAyanami<M, State>] : never;
