import { ConstructorOf } from '../core/types';
import { Ayanami } from '../core/ayanami';
export declare type ModuleMeta = ConstructorOf<Ayanami<any>>;
/**
 * Run all @SSREffect decorated effects of given modules and extract latest states.
 * `cleanup` function returned must be called before end of responding
 *
 * @param ctx request context, which will be passed to payloadGetter in SSREffect decorator param
 * @param modules used ayanami modules
 * @param uuid the same uuid would reuse the same state which was created before
 * @param timeout seconds to wait before all effects stream out TERMINATE_ACTION
 * @returns object contains ayanami state and cleanup function
 */
export declare const runSSREffects: <Context, Returned = any>(ctx: Context, modules: ModuleMeta[], sharedCtx?: string | symbol | undefined, timeout?: number) => Promise<Returned>;
