import { TestModule } from '@asuka/di';
export class AyanamiTestModule extends TestModule {
    getAyanamiTestingStub(ayanamiModule) {
        const moduleInstance = this.getInstance(ayanamiModule);
        const state = moduleInstance.createState();
        const actionsCreator = moduleInstance.getActions();
        const dispatcher = Object.keys(actionsCreator).reduce((acc, key) => {
            acc[key] = (payload) => {
                state.dispatch(actionsCreator[key](payload));
            };
            return acc;
        }, Object.create(null));
        return new AyanamiTestStub(dispatcher, state);
    }
}
export class AyanamiTestStub {
    constructor(dispatcher, state) {
        this.dispatcher = dispatcher;
        this.state = state;
    }
    getState() {
        return this.state.getState();
    }
}
